diff --git a/src/http/modules/ngx_http_empty_gif_module.c b/src/http/modules/ngx_http_empty_gif_module.c
index e6515df..e1a5749 100644
--- a/src/http/modules/ngx_http_empty_gif_module.c
+++ b/src/http/modules/ngx_http_empty_gif_module.c
@@ -8,9 +8,27 @@
 #include <ngx_http.h>
 
 
+typedef struct {
+    size_t     size;
+    ngx_str_t  str;
+} ngx_http_empty_gif_fake_t;
+
+typedef struct {
+    ngx_http_empty_gif_fake_t fake;
+} ngx_http_empty_gif_loc_conf_t;
+
+
 static char *ngx_http_empty_gif(ngx_conf_t *cf, ngx_command_t *cmd,
     void *conf);
 
+static void *ngx_http_empty_gif_create_local_conf(ngx_conf_t *cf);
+static char *ngx_http_empty_gif_merge_local_conf(ngx_conf_t *cf,
+    void *parent, void *child);
+
+static char *ngx_http_empty_gif_size(ngx_conf_t *cf,
+    ngx_command_t *cmd, void *conf);
+
+
 static ngx_command_t  ngx_http_empty_gif_commands[] = {
 
     { ngx_string("empty_gif"),
@@ -20,6 +38,14 @@ static ngx_command_t  ngx_http_empty_gif_commands[] = {
       0,
       NULL },
 
+    { ngx_string("empty_gif_size"),
+      NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_HTTP_LIF_CONF
+                        |NGX_CONF_TAKE12,
+      ngx_http_empty_gif_size,
+      NGX_HTTP_LOC_CONF_OFFSET,
+      offsetof(ngx_http_empty_gif_loc_conf_t, fake),
+      NULL },
+
       ngx_null_command
 };
 
@@ -75,32 +101,32 @@ static u_char  ngx_empty_gif[] = {
 
 
 static ngx_http_module_t  ngx_http_empty_gif_module_ctx = {
-    NULL,                          /* preconfiguration */
-    NULL,                          /* postconfiguration */
+    NULL,                                  /* preconfiguration */
+    NULL,                                  /* postconfiguration */
 
-    NULL,                          /* create main configuration */
-    NULL,                          /* init main configuration */
+    NULL,                                  /* create main configuration */
+    NULL,                                  /* init main configuration */
 
-    NULL,                          /* create server configuration */
-    NULL,                          /* merge server configuration */
+    NULL,                                  /* create server configuration */
+    NULL,                                  /* merge server configuration */
 
-    NULL,                          /* create location configuration */
-    NULL                           /* merge location configuration */
+    ngx_http_empty_gif_create_local_conf,  /* create location configuration */
+    ngx_http_empty_gif_merge_local_conf    /* merge location configuration */
 };
 
 
 ngx_module_t  ngx_http_empty_gif_module = {
     NGX_MODULE_V1,
-    &ngx_http_empty_gif_module_ctx, /* module context */
-    ngx_http_empty_gif_commands,   /* module directives */
-    NGX_HTTP_MODULE,               /* module type */
-    NULL,                          /* init master */
-    NULL,                          /* init module */
-    NULL,                          /* init process */
-    NULL,                          /* init thread */
-    NULL,                          /* exit thread */
-    NULL,                          /* exit process */
-    NULL,                          /* exit master */
+    &ngx_http_empty_gif_module_ctx,   /* module context */
+    ngx_http_empty_gif_commands,      /* module directives */
+    NGX_HTTP_MODULE,                  /* module type */
+    NULL,                             /* init master */
+    NULL,                             /* init module */
+    NULL,                             /* init process */
+    NULL,                             /* init thread */
+    NULL,                             /* exit thread */
+    NULL,                             /* exit process */
+    NULL,                             /* exit master */
     NGX_MODULE_V1_PADDING
 };
 
@@ -108,9 +134,13 @@ ngx_module_t  ngx_http_empty_gif_module = {
 static ngx_int_t
 ngx_http_empty_gif_handler(ngx_http_request_t *r)
 {
-    ngx_int_t     rc;
-    ngx_buf_t    *b;
-    ngx_chain_t   out;
+    ngx_int_t                       rc;
+    ngx_buf_t                      *b = NULL;
+    ngx_uint_t                      i, out_count;
+    ngx_chain_t                    *out;
+    ngx_http_empty_gif_loc_conf_t  *conf;
+
+    conf = ngx_http_get_module_loc_conf(r, ngx_http_empty_gif_module);
 
     if (!(r->method & (NGX_HTTP_GET|NGX_HTTP_HEAD))) {
         return NGX_HTTP_NOT_ALLOWED;
@@ -129,35 +159,76 @@ ngx_http_empty_gif_handler(ngx_http_request_t *r)
     if (r->method == NGX_HTTP_HEAD) {
         r->headers_out.status = NGX_HTTP_OK;
         r->headers_out.content_length_n = sizeof(ngx_empty_gif);
+        if (conf->fake.size) {
+            r->headers_out.content_length_n += conf->fake.size;
+        }
         r->headers_out.last_modified_time = 23349600;
 
+        r->headers_out.etag_size = 40;
+        r->headers_out.etag_time = 5;
+        r->headers_out.etag_uniq = 6535;
+
+
         return ngx_http_send_header(r);
     }
 
-    b = ngx_pcalloc(r->pool, sizeof(ngx_buf_t));
-    if (b == NULL) {
-        return NGX_HTTP_INTERNAL_SERVER_ERROR;
+    out_count = 1;
+    if (conf->fake.size) {
+        out_count += conf->fake.size / conf->fake.str.len;
+        if (conf->fake.size % conf->fake.str.len) {
+            out_count++;
+        }
     }
 
-    out.buf = b;
-    out.next = NULL;
+    out = ngx_palloc(r->pool, sizeof(ngx_chain_t) * out_count);
+    if (out == NULL) {
+        return NGX_HTTP_INTERNAL_SERVER_ERROR;
+    }
 
-    b->pos = ngx_empty_gif;
-    b->last = ngx_empty_gif + sizeof(ngx_empty_gif);
-    b->memory = 1;
-    b->last_buf = 1;
+    for (i = 0; i < out_count; i++) {
+        b = ngx_pcalloc(r->pool, sizeof(ngx_buf_t));
+        if (b == NULL) {
+            return NGX_HTTP_INTERNAL_SERVER_ERROR;
+        }
+
+        out[i].buf = b;
+
+        if (0 == i) {
+            out[i].next = NULL;
+            b->pos = b->start = ngx_empty_gif;
+            b->last = b->end = ngx_empty_gif + sizeof(ngx_empty_gif);
+        } else if ((conf->fake.size / conf->fake.str.len) + 1 == i) {
+            out[i-1].next = &out[i];
+            out[i].next = NULL;
+            b->pos = b->start = conf->fake.str.data;
+            b->last = b->end = conf->fake.str.data + conf->fake.size % conf->fake.str.len;
+        } else {
+            out[i-1].next = &out[i];
+            out[i].next = NULL;
+            b->pos = b->start = conf->fake.str.data;
+            b->last = b->end = conf->fake.str.data + conf->fake.str.len;
+        }
+
+        b->memory = 1;
+    }
 
     r->headers_out.status = NGX_HTTP_OK;
-    r->headers_out.content_length_n = sizeof(ngx_empty_gif);
+    r->headers_out.content_length_n = sizeof(ngx_empty_gif) + conf->fake.size;
     r->headers_out.last_modified_time = 23349600;
 
+    b->last_buf = 1;
+
+    r->headers_out.etag_size = 40;
+    r->headers_out.etag_time = 5;
+    r->headers_out.etag_uniq = 6535;
+
     rc = ngx_http_send_header(r);
 
     if (rc == NGX_ERROR || rc > NGX_OK || r->header_only) {
         return rc;
     }
 
-    return ngx_http_output_filter(r, &out);
+    return ngx_http_output_filter(r, out);
 }
 
 
@@ -171,3 +242,87 @@ ngx_http_empty_gif(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
 
     return NGX_CONF_OK;
 }
+
+
+static void *
+ngx_http_empty_gif_create_local_conf(ngx_conf_t *cf)
+{
+    ngx_http_empty_gif_loc_conf_t  *conf;
+
+    conf = ngx_pcalloc(cf->pool, sizeof(ngx_http_empty_gif_loc_conf_t));
+    if (conf == NULL) {
+        return NGX_CONF_ERROR;
+    }
+
+    return conf;
+}
+
+static char *
+ngx_http_empty_gif_merge_local_conf(ngx_conf_t *cf, void *parent, void *child)
+{
+    ngx_http_empty_gif_loc_conf_t  *prev = parent;
+    ngx_http_empty_gif_loc_conf_t  *conf = child;
+
+    if (prev->fake.size) {
+        conf->fake = prev->fake;
+    }
+
+    return NGX_CONF_OK;
+}
+
+static char *
+ngx_http_empty_gif_size(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
+{
+    char  *p = conf;
+
+    ngx_str_t                 *value;
+    ngx_int_t                  i = 1;
+    ngx_conf_post_t           *post;
+    ngx_http_empty_gif_fake_t *field;
+
+    field = (ngx_http_empty_gif_fake_t *) (p + cmd->offset);
+
+    if (field->str.data) {
+        return "is duplicate";
+    }
+
+    value = cf->args->elts;
+
+    if (cf->args->nelts == 3) {
+        field->str.len = ngx_parse_size(&value[i]);
+        if (field->str.len == (size_t) NGX_ERROR) {
+            return "invalid value";
+        }
+        i++;
+    } else {
+        field->str.len = 1024;
+    }
+
+    field->size = ngx_parse_size(&value[i]);
+
+    if (field->size == (size_t) NGX_ERROR) {
+        return "invalid value";
+    }
+
+    if (field->size < sizeof(ngx_empty_gif)) {
+        return "is shortly";
+    }
+
+    field->size -= sizeof(ngx_empty_gif);
+
+    if (field->str.len > field->size) {
+        field->str.len = field->size;
+    }
+
+    field->str.data = ngx_pcalloc(cf->pool, field->str.len);
+    if (field->str.data == NULL) {
+        return NGX_CONF_ERROR;
+    }
+
+    if (cmd->post) {
+        post = cmd->post;
+        return post->post_handler(cf, post, field);
+    }
+
+    return NGX_CONF_OK;
+}
diff --git a/src/http/modules/ngx_http_flv_module.c b/src/http/modules/ngx_http_flv_module.c
index 2afeb28..4dd0302 100644
--- a/src/http/modules/ngx_http_flv_module.c
+++ b/src/http/modules/ngx_http_flv_module.c
@@ -188,6 +188,10 @@ ngx_http_flv_handler(ngx_http_request_t *r)
     r->headers_out.content_length_n = len;
     r->headers_out.last_modified_time = of.mtime;
 
+    r->headers_out.etag_size = of.size;
+    r->headers_out.etag_time = of.mtime;
+    r->headers_out.etag_uniq = of.uniq;
+
     if (ngx_http_set_content_type(r) != NGX_OK) {
         return NGX_HTTP_INTERNAL_SERVER_ERROR;
     }
diff --git a/src/http/modules/ngx_http_gzip_static_module.c b/src/http/modules/ngx_http_gzip_static_module.c
index a184862..a091ef2 100644
--- a/src/http/modules/ngx_http_gzip_static_module.c
+++ b/src/http/modules/ngx_http_gzip_static_module.c
@@ -189,6 +189,10 @@ ngx_http_gzip_static_handler(ngx_http_request_t *r)
     r->headers_out.content_length_n = of.size;
     r->headers_out.last_modified_time = of.mtime;
 
+    r->headers_out.etag_size = of.size;
+    r->headers_out.etag_time = of.mtime;
+    r->headers_out.etag_uniq = of.uniq;
+
     if (ngx_http_set_content_type(r) != NGX_OK) {
         return NGX_HTTP_INTERNAL_SERVER_ERROR;
     }
diff --git a/src/http/modules/ngx_http_is_bot_module.c b/src/http/modules/ngx_http_is_bot_module.c
new file mode 100644
index 0000000..73f5caf
--- /dev/null
+++ b/src/http/modules/ngx_http_is_bot_module.c
@@ -0,0 +1,282 @@
+
+/*
+ * Copyright (C) Kirill A. Korinskiy
+ */
+
+
+#include <ngx_config.h>
+#include <ngx_core.h>
+#include <ngx_http.h>
+
+typedef struct {
+    ngx_str_t         by;
+    ngx_array_t      *by_lengths;
+    ngx_array_t      *by_values;
+    ngx_rbtreehash_t  data;
+} ngx_http_is_bot_loc_conf_t;
+
+typedef struct {
+    ngx_str_t         bot;
+} ngx_http_is_bot_ctx_t;
+
+static ngx_int_t ngx_http_is_bot_add_variable(ngx_conf_t *cf);
+
+static void *ngx_http_is_bot_create_loc_conf(ngx_conf_t *cf);
+static char *ngx_http_is_bot_merge_loc_conf(ngx_conf_t *cf,
+    void *parent, void *child);
+
+static char *ngx_http_is_bot_set_by_slot(ngx_conf_t *cf,
+    ngx_command_t *cmd, void *conf);
+
+static ngx_http_is_bot_ctx_t *ngx_http_is_bot_get_ctx(ngx_http_request_t *r);
+
+static ngx_command_t  ngx_http_is_bot_commands[] = {
+
+    { ngx_string("is_bot_by"),
+      NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_TAKE1,
+      ngx_http_is_bot_set_by_slot,
+      NGX_HTTP_LOC_CONF_OFFSET,
+      0,
+      NULL },
+
+    { ngx_string("is_bot_data"),
+      NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_TAKE1,
+      ngx_rbtreehash_from_path,
+      NGX_HTTP_LOC_CONF_OFFSET,
+      offsetof(ngx_http_is_bot_loc_conf_t, data),
+      NULL },
+
+      ngx_null_command
+};
+
+
+static ngx_http_module_t  ngx_http_is_bot_module_ctx = {
+    ngx_http_is_bot_add_variable,        /* preconfiguration */
+    NULL,                                /* postconfiguration */
+
+    NULL,                                /* create main configuration */
+    NULL,                                /* init main configuration */
+
+    NULL,	                         /* create server configuration */
+    NULL,			         /* merge server configuration */
+
+    ngx_http_is_bot_create_loc_conf,     /* create location configuration */
+    ngx_http_is_bot_merge_loc_conf       /* merge location configuration */
+};
+
+
+ngx_module_t  ngx_http_is_bot_module = {
+    NGX_MODULE_V1,
+    &ngx_http_is_bot_module_ctx,           /* module context */
+    ngx_http_is_bot_commands,              /* module directives */
+    NGX_HTTP_MODULE,                       /* module type */
+    NULL,                                  /* init master */
+    NULL,                                  /* init module */
+    NULL,                                  /* init process */
+    NULL,                                  /* init thread */
+    NULL,                                  /* exit thread */
+    NULL,                                  /* exit process */
+    NULL,                                  /* exit master */
+    NGX_MODULE_V1_PADDING
+};
+
+static ngx_str_t  ngx_http_is_bot_variable_name = ngx_string("is_bot");
+
+static ngx_int_t
+ngx_http_is_bot_variable(ngx_http_request_t *r,
+    ngx_http_variable_value_t *v, uintptr_t data)
+{
+    ngx_http_is_bot_ctx_t          *ctx;
+
+    ctx = ngx_http_is_bot_get_ctx(r);
+
+    if (ctx == NULL) {
+	return NGX_ERROR;
+    }
+
+
+    if (!ctx->bot.data || (ngx_int_t)ctx->bot.len < 0) {
+	v->not_found = 1;
+	return NGX_OK;
+    }
+
+    v->len = ctx->bot.len;
+    v->data = ctx->bot.data;
+
+    v->valid = 1;
+    v->no_cacheable = 0;
+    v->not_found = 0;
+
+    return NGX_OK;
+}
+
+static ngx_int_t
+ngx_http_is_bot_add_variable(ngx_conf_t *cf)
+{
+  ngx_http_variable_t  *var;
+
+  var = ngx_http_add_variable(cf, &ngx_http_is_bot_variable_name, NGX_HTTP_VAR_NOHASH);
+  if (var == NULL) {
+    return NGX_ERROR;
+  }
+
+  var->get_handler = ngx_http_is_bot_variable;
+
+  return NGX_OK;
+}
+
+static ngx_http_is_bot_ctx_t *
+ngx_http_is_bot_get_ctx(ngx_http_request_t *r)
+{
+    ngx_str_t                       by;
+    ngx_http_script_code_pt         code;
+    ngx_http_script_engine_t        e;
+    ngx_http_script_len_code_pt     lcode;
+    ngx_http_is_bot_loc_conf_t     *blcf;
+    ngx_http_is_bot_ctx_t          *ctx;
+
+    ctx = ngx_http_get_module_ctx(r, ngx_http_is_bot_module);
+
+    if (ctx != NULL) {
+	return ctx;
+    }
+
+    ctx = ngx_pcalloc(r->pool, sizeof(ngx_http_is_bot_ctx_t));
+    if (ctx == NULL) {
+	return NULL;
+    }
+
+    blcf = ngx_http_get_module_loc_conf(r, ngx_http_is_bot_module);
+
+    if (blcf->data.data == NULL) {
+        return NULL;
+    }
+
+    if (blcf->data.data->nodes == 0) {
+	return ctx;
+    }
+
+    if (blcf->by_lengths == NULL &&
+	blcf->by_values == NULL) {
+	by = blcf->by;
+    } else {
+	ngx_memzero(&e, sizeof(ngx_http_script_engine_t));
+	e.ip = blcf->by_lengths->elts;
+	e.request = r;
+	e.flushed = 1;
+
+	by.len = 1;		/* 1 byte for terminating '\0' */
+
+	while (*(uintptr_t *) e.ip) {
+	    lcode = *(ngx_http_script_len_code_pt *) e.ip;
+	    by.len += lcode(&e);
+	}
+
+	by.data = ngx_pcalloc(r->pool, by.len);
+	if (by.data == NULL) {
+	    return NULL;
+	}
+
+	e.pos = by.data;
+	e.ip = blcf->by_values->elts;
+
+	while (*(uintptr_t *) e.ip) {
+	    code = *(ngx_http_script_code_pt *) e.ip;
+	    code((ngx_http_script_engine_t *) &e);
+	}
+
+	by.len = e.pos - by.data;
+    }
+
+    ctx->bot.data = ngx_rbtreehash_find(&blcf->data, &by, &ctx->bot.len);
+
+    ngx_http_set_ctx(r, ctx, ngx_http_is_bot_module);
+
+    return ctx;
+}
+
+
+static void *
+ngx_http_is_bot_create_loc_conf(ngx_conf_t *cf)
+{
+    ngx_http_is_bot_loc_conf_t  *conf;
+
+    conf = ngx_pcalloc(cf->pool, sizeof(ngx_http_is_bot_loc_conf_t));
+    if (conf == NULL) {
+        return NGX_CONF_ERROR;
+    }
+
+    return conf;
+}
+
+
+static char *
+ngx_http_is_bot_merge_loc_conf(ngx_conf_t *cf, void *parent, void *child)
+{
+    ngx_http_is_bot_loc_conf_t  *prev = parent;
+    ngx_http_is_bot_loc_conf_t  *conf = child;
+
+    if (prev->by.len) {
+	conf->by = prev->by;
+	conf->by_values = prev->by_values;
+	conf->by_lengths = prev->by_lengths;
+    }
+
+    return NGX_CONF_OK;
+}
+
+
+static char *
+ngx_http_is_bot_set_by_slot(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
+{
+    ngx_http_is_bot_loc_conf_t      *blcf = conf;
+    ngx_str_t                       *value;
+    ngx_uint_t                       n;
+    ngx_http_script_compile_t        sc; 
+
+    if (blcf->by.data) {
+	return "is duplicate";
+    }
+
+    value = cf->args->elts;
+
+    if (value[1].len == 0) {
+	ngx_conf_log_error(NGX_LOG_EMERG, cf, 0,
+			   "region \"%V\" in \"%V\" directive is invalid",
+			   &value[1], &value[0]);
+	return NGX_CONF_ERROR;
+    }
+
+    blcf->by = value[1];
+
+    n = ngx_http_script_variables_count(&blcf->by);
+
+    if (n == 0) {
+	/* include the terminating '\0' to the length to use ngx_copy()*/
+	blcf->by.len++;
+
+	return NGX_CONF_OK;
+    }
+
+    ngx_memzero(&sc, sizeof(ngx_http_script_compile_t));
+
+    sc.cf = cf;
+    sc.source = &blcf->by;
+    sc.lengths = &blcf->by_lengths;
+    sc.values = &blcf->by_values;
+    sc.variables = n;
+    sc.complete_lengths = 1;
+    sc.complete_values = 1;
+
+    if (ngx_http_script_compile(&sc) != NGX_OK) {
+	return NGX_CONF_ERROR;
+    }
+
+    return NGX_CONF_OK;
+}
+
+/* Local Variables: */
+/* mode: c */
+/* c-basic-offset: 4 */
+/* c-file-offsets: ((arglist-cont-nonempty . 4)) */
+/* End: */
diff --git a/src/http/modules/ngx_http_limit_var_module.c b/src/http/modules/ngx_http_limit_var_module.c
new file mode 100644
index 0000000..53e42d6
--- /dev/null
+++ b/src/http/modules/ngx_http_limit_var_module.c
@@ -0,0 +1,338 @@
+
+/*
+ * Copyright (C) Kirill A. Korinskiy
+ */
+
+
+#include <ngx_config.h>
+#include <ngx_core.h>
+#include <ngx_http.h>
+
+
+typedef struct {
+    ngx_flathash_t           *hash;
+    ngx_uint_t                size;
+    ngx_uint_t                rate;
+    ngx_shmtx_t               mutex;
+    ngx_http_complex_value_t  key;
+} ngx_http_limit_var_ctx_t;
+
+
+static char *ngx_http_limit_var(ngx_conf_t *cf, ngx_command_t *cmd,
+    void *conf);
+
+
+static ngx_command_t  ngx_http_limit_var_commands[] = {
+
+    { ngx_string("limit_var"),
+      NGX_HTTP_MAIN_CONF|NGX_CONF_TAKE3,
+      ngx_http_limit_var,
+      0,
+      0,
+      NULL },
+
+      ngx_null_command
+};
+
+
+static ngx_http_module_t  ngx_http_limit_var_module_ctx = {
+    NULL,                                  /* preconfiguration */
+    NULL,                                  /* postconfiguration */
+
+    NULL,                                  /* create main configuration */
+    NULL,                                  /* init main configuration */
+
+    NULL,                                  /* create server configuration */
+    NULL,                                  /* merge server configuration */
+
+    NULL,                                  /* create location configration */
+    NULL                                   /* merge location configration */
+};
+
+
+ngx_module_t  ngx_http_limit_var_module = {
+    NGX_MODULE_V1,
+    &ngx_http_limit_var_module_ctx,        /* module context */
+    ngx_http_limit_var_commands,           /* module directives */
+    NGX_HTTP_MODULE,                       /* module type */
+    NULL,                                  /* init master */
+    NULL,                                  /* init module */
+    NULL,                                  /* init process */
+    NULL,                                  /* init thread */
+    NULL,                                  /* exit thread */
+    NULL,                                  /* exit process */
+    NULL,                                  /* exit master */
+    NGX_MODULE_V1_PADDING
+};
+
+
+static ngx_int_t
+ngx_http_limit_var_variable(ngx_http_request_t *r, ngx_http_variable_value_t *v,
+    uintptr_t data)
+{
+    ngx_http_limit_var_ctx_t   *ctx = (ngx_http_limit_var_ctx_t *)data;
+
+
+    ngx_str_t                   key;
+
+    time_t                     *value;
+    ngx_uint_t                  frequency = 0;
+
+    if (ngx_http_complex_value(r, &ctx->key, &key) != NGX_OK) {
+        return NGX_ERROR;
+    }
+
+    if (key.len == 0) {
+        v->not_found = 1;
+        return NGX_OK;
+    }
+
+    r->main->limit_var_set = 1;
+
+    value = ngx_flathash_get(ctx->hash, &key);
+
+    ngx_shmtx_lock(&ctx->mutex);
+
+    /* intreting only a less 16 bit of state */
+
+    /* have activity in this second */
+    if ((*value & 0xFFFF) == (ngx_time() & 0xFFFF)) {
+	frequency = (ngx_uint_t)*value >> 16;
+    }
+
+    if (r->main->limit_var_set) {
+	*value = (frequency + 1) << 16 | (ngx_time() & 0xFFFF);
+    }
+
+    ngx_shmtx_unlock(&ctx->mutex);
+
+    if (frequency > ctx->rate) {
+	goto outcast;
+    }
+
+    v->not_found = 1;
+    return NGX_OK;
+
+  outcast:
+
+    ngx_log_error(NGX_LOG_INFO, r->connection->log, 0,
+		  "limiting requests, excess %d",
+		  frequency);
+
+
+    v->data = ngx_pnalloc(r->pool, NGX_INT_T_LEN);
+    if (v->data == NULL) {
+        return NGX_ERROR;
+    }
+
+    v->len = ngx_sprintf(v->data, "%d", frequency) - v->data;
+    v->valid = 1;
+    v->no_cacheable = 0;
+    v->not_found = 0;
+
+    return NGX_OK;
+}
+
+
+static ngx_int_t
+ngx_http_limit_var_init_zone(ngx_shm_zone_t *shm_zone, void *data)
+{
+    ngx_http_limit_var_ctx_t  *octx = data;
+
+    ngx_http_limit_var_ctx_t  *ctx;
+
+    ctx = shm_zone->data;
+
+    if (octx) {
+        if (ngx_strcmp(ctx->key.value.data, octx->key.value.data) != 0) {
+            ngx_log_error(NGX_LOG_EMERG, shm_zone->shm.log, 0,
+                          "limit_req \"%V\" uses the \"%V\" key "
+                          "while previously it used the \"%V\" key",
+                          &shm_zone->shm.name, &ctx->key.value, &octx->key.value);
+            return NGX_ERROR;
+        }
+
+        ctx->hash = octx->hash;
+
+        return NGX_OK;
+    }
+
+    ctx->mutex.lock = (ngx_atomic_t *) shm_zone->shm.addr;
+
+    ctx->hash = (ngx_flathash_t *) ((u_char *)shm_zone->shm.addr + sizeof(ngx_atomic_t));
+
+    /* value of hash is a time_t */
+
+    if (ngx_flathash_init(ctx->hash, sizeof(time_t), ctx->size) != NGX_OK) {
+        return NGX_ERROR;
+    }
+
+    return NGX_OK;
+}
+
+
+static char *
+ngx_http_limit_var(ngx_conf_t *cf, ngx_command_t *cmd, void *conf)
+{
+    u_char                    *p;
+    size_t                     size, len;
+    ngx_str_t                 *value, name, s;
+    ngx_int_t                  rate;
+    ngx_uint_t                 i;
+    ngx_shm_zone_t            *shm_zone;
+    ngx_http_variable_t       *var;
+    ngx_http_limit_var_ctx_t  *ctx;
+
+    ngx_http_compile_complex_value_t   ccv;
+
+    if (sizeof(time_t) < 4) {
+        ngx_conf_log_error(NGX_LOG_EMERG, cf, 0,
+                           "Sorry. ngx_http_limit_var_module required a system"
+			   " with more or equal 32 bit for time_t");
+        return NGX_CONF_ERROR;
+    }
+
+
+
+    value = cf->args->elts;
+
+    ctx = NULL;
+    size = 0;
+    rate = 1;
+    name.len = 0;
+
+    for (i = 1; i < cf->args->nelts; i++) {
+
+        if (ngx_strncmp(value[i].data, "zone=", 5) == 0) {
+
+            name.data = value[i].data + 5;
+
+            p = (u_char *) ngx_strchr(name.data, ':');
+
+            if (p) {
+                name.len = p - name.data;
+
+                p++;
+
+                s.len = value[i].data + value[i].len - p;
+                s.data = p;
+
+                size = ngx_atoi(s.data, s.len);
+                if ((ngx_int_t)size != NGX_ERROR && size > 769) {
+                    continue;
+                }
+            }
+
+            ngx_conf_log_error(NGX_LOG_EMERG, cf, 0,
+                               "invalid zone size \"%V\"", &value[i]);
+            return NGX_CONF_ERROR;
+        }
+
+        if (ngx_strncmp(value[i].data, "rate=", 5) == 0) {
+
+            len = value[i].len;
+            p = value[i].data + len - 3;
+
+            if (ngx_strncmp(p, "r/s", 3) == 0) {
+                len -= 3;
+            }
+
+            rate = ngx_atoi(value[i].data + 5, len - 5);
+            if (rate <= NGX_ERROR) {
+                ngx_conf_log_error(NGX_LOG_EMERG, cf, 0,
+                                   "invalid rate \"%V\"", &value[i]);
+                return NGX_CONF_ERROR;
+            }
+
+            continue;
+        }
+
+        if (value[i].data[0] == '$') {
+
+            value[i].len--;
+            value[i].data++;
+
+            ctx = ngx_pcalloc(cf->pool, sizeof(ngx_http_limit_var_ctx_t));
+            if (ctx == NULL) {
+                return NGX_CONF_ERROR;
+            }
+
+            ngx_memzero(&ccv, sizeof(ngx_http_compile_complex_value_t));
+
+            ccv.cf = cf;
+            ccv.value = &value[1];
+            ccv.complex_value = &ctx->key;
+            ccv.zero = 1;
+            ccv.conf_prefix = 1;
+
+            if (ngx_http_compile_complex_value(&ccv) != NGX_OK) {
+                return NGX_CONF_ERROR;
+            }
+
+            continue;
+        }
+
+        ngx_conf_log_error(NGX_LOG_EMERG, cf, 0,
+                           "invalid parameter \"%V\"", &value[i]);
+        return NGX_CONF_ERROR;
+    }
+
+    if (name.len == 0 || size == 0) {
+        ngx_conf_log_error(NGX_LOG_EMERG, cf, 0,
+                           "\"%V\" must have \"zone\" parameter",
+                           &cmd->name);
+        return NGX_CONF_ERROR;
+    }
+
+    if (ctx == NULL) {
+        ngx_conf_log_error(NGX_LOG_EMERG, cf, 0,
+                           "no var is defined for limit_var_zone \"%V\"",
+                           &cmd->name);
+        return NGX_CONF_ERROR;
+    }
+
+    ctx->rate = rate;
+
+    ctx->size = size;
+
+    /* value of hash is a time_t */
+    size = ngx_flathash_need_memory(sizeof(time_t), size);
+
+    size += sizeof(ngx_atomic_t);
+
+    shm_zone = ngx_shared_memory_add(cf, &name, size,
+                                     &ngx_http_limit_var_module);
+    if (shm_zone == NULL) {
+        return NGX_CONF_ERROR;
+    }
+
+    if (shm_zone->data) {
+        ctx = shm_zone->data;
+
+        ngx_conf_log_error(NGX_LOG_EMERG, cf, 0,
+                   "limit_var_zone \"%V\" is already bound to var \"%V\"",
+                   &value[1], &ctx->key.value);
+        return NGX_CONF_ERROR;
+    }
+
+    shm_zone->init = ngx_http_limit_var_init_zone;
+    shm_zone->data = ctx;
+
+    s.len = sizeof("limit_var_") - 1 + name.len;
+    s.data = ngx_palloc(cf->pool, s.len);
+    if (s.data == NULL) {
+        return NGX_CONF_ERROR;
+    }
+
+    ngx_sprintf(s.data, "limit_var_%V", &name);
+
+    var = ngx_http_add_variable(cf, &s, NGX_HTTP_VAR_NOCACHEABLE);
+    if (var == NULL) {
+        return NGX_CONF_ERROR;
+    }
+
+    var->get_handler = ngx_http_limit_var_variable;
+    var->data = (uintptr_t) ctx;
+
+    return NGX_CONF_OK;
+}
diff --git a/src/http/modules/ngx_http_not_modified_filter_module.c b/src/http/modules/ngx_http_not_modified_filter_module.c
index 5312b3a..1e86ead 100644
--- a/src/http/modules/ngx_http_not_modified_filter_module.c
+++ b/src/http/modules/ngx_http_not_modified_filter_module.c
@@ -50,13 +50,18 @@ static ngx_http_output_header_filter_pt  ngx_http_next_header_filter;
 static ngx_int_t
 ngx_http_not_modified_header_filter(ngx_http_request_t *r)
 {
+    u_char                    *p, *etag;
     time_t                     ims;
     ngx_http_core_loc_conf_t  *clcf;
 
     if (r->headers_out.status != NGX_HTTP_OK
         || r != r->main
-        || r->headers_in.if_modified_since == NULL
-        || r->headers_out.last_modified_time == -1)
+        || ((r->headers_in.if_modified_since == NULL
+             || r->headers_out.last_modified_time == -1)
+            && (r->headers_in.if_match == NULL
+                || r->headers_out.etag_size == -1
+                || r->headers_out.etag_time == -1
+                || r->headers_out.etag_uniq == (ngx_file_uniq_t) -1)))
     {
         return ngx_http_next_header_filter(r);
     }
@@ -67,6 +72,28 @@ ngx_http_not_modified_header_filter(ngx_http_request_t *r)
         return ngx_http_next_header_filter(r);
     }
 
+    if (r->headers_in.if_match) {
+        etag = ngx_palloc(r->pool, NGX_OFF_T_LEN + sizeof("_") - 1
+                       + NGX_TIME_T_LEN + sizeof("_") - 1 + NGX_INT_T_LEN);
+
+	if (etag == NULL) {
+            return NGX_ERROR;
+	}
+
+        p = ngx_sprintf(etag, "%XO-%XM-%Xd",
+                        r->headers_out.etag_size,
+                        r->headers_out.etag_time,
+                        r->headers_out.etag_uniq);
+
+	if (ngx_strncmp(r->headers_in.if_match->value.data, etag,
+                        (ngx_uint_t)(etag - p) > r->headers_in.if_match->value.len ?
+                        (ngx_uint_t)(etag - p) : r->headers_in.if_match->value.len)) {
+            return ngx_http_next_header_filter(r);
+        }
+
+      goto  not_modified;
+    }
+
     ims = ngx_http_parse_time(r->headers_in.if_modified_since->value.data,
                               r->headers_in.if_modified_since->value.len);
 
@@ -82,6 +109,8 @@ ngx_http_not_modified_header_filter(ngx_http_request_t *r)
         }
     }
 
+ not_modified:
+
     r->headers_out.status = NGX_HTTP_NOT_MODIFIED;
     r->headers_out.status_line.len = 0;
     r->headers_out.content_type.len = 0;
diff --git a/src/http/modules/ngx_http_range_filter_module.c b/src/http/modules/ngx_http_range_filter_module.c
index f708c87..5559be7 100644
--- a/src/http/modules/ngx_http_range_filter_module.c
+++ b/src/http/modules/ngx_http_range_filter_module.c
@@ -146,6 +146,7 @@ static ngx_int_t
 ngx_http_range_header_filter(ngx_http_request_t *r)
 {
     time_t                        if_range;
+    u_char                       *p, *etag;
     ngx_int_t                     rc;
     ngx_http_range_filter_ctx_t  *ctx;
 
@@ -172,13 +173,39 @@ ngx_http_range_header_filter(ngx_http_request_t *r)
         if_range = ngx_http_parse_time(r->headers_in.if_range->value.data,
                                        r->headers_in.if_range->value.len);
 
-        ngx_log_debug2(NGX_LOG_DEBUG_HTTP, r->connection->log, 0,
-                       "http ir:%d lm:%d",
-                       if_range, r->headers_out.last_modified_time);
+	if (if_range != NGX_ERROR) {
+
+            ngx_log_debug2(NGX_LOG_DEBUG_HTTP, r->connection->log, 0,
+	                   "http ir:%d lm:%d",
+                           if_range, r->headers_out.last_modified_time);
+
+            if (if_range != r->headers_out.last_modified_time) {
+                goto next_filter;
+            }
+	}
+    }
 
-        if (if_range != r->headers_out.last_modified_time) {
+    if (r->headers_in.if_range && r->headers_out.etag_size != -1
+        && r->headers_out.etag_time != -1
+        && r->headers_out.etag_uniq != (ngx_file_uniq_t) -1) {
+        etag = ngx_palloc(r->pool, NGX_OFF_T_LEN + sizeof("_") - 1
+                       + NGX_TIME_T_LEN + sizeof("_") - 1 + NGX_INT_T_LEN);
+
+	if (etag == NULL) {
+            return NGX_ERROR;
+	}
+
+        p = ngx_sprintf(etag, "%XO-%XM-%Xd",
+                        r->headers_out.etag_size,
+                        r->headers_out.etag_time,
+                        r->headers_out.etag_uniq);
+
+	if (ngx_strncmp(r->headers_in.if_range->value.data, etag,
+                        (ngx_uint_t)(etag - p) > r->headers_in.if_range->value.len ?
+                        (ngx_uint_t)(etag - p) : r->headers_in.if_range->value.len)) {
             goto next_filter;
         }
+
     }
 
     ctx = ngx_pcalloc(r->pool, sizeof(ngx_http_range_filter_ctx_t));
